; TIP1188.LSP: TL.LSP   Text Leader   (c)1996, Andrew Sloss

(defun *error* (msg)
  (command "layer" "s" LA "")
  (princ msg)
  (princ)
)
(defun C:TL ( / LA S1A S1 PT1 H1 A2 TLANGLE TXT PT2 A1 D1 W1 PT3 PT4 PT5
    TXTA H TXTOJ TXTNJ TXTB INPT ALPT D2 D3 N1 N2 PT6 D4 PT7
  PT8 PT9)
  (setq LA (getvar "clayer"))
  (setvar "cmdecho" 1)
  (setq S1A (getvar "dimscale"))
  (if (/= S1A 0) (setq *S1A NIL))
  (if (and (= S1A 0) (not *S1A))
    (progn
      (setq S1A (getdist "\nDIMSCALE=0, Please enter scale factor: "))
      (setq *S1A S1A)
    );END PROGN
  );END IF
  (if *S1A
    (setq S1 *S1A)
    (setq S1 S1A)
  );END IF
  (initget 1)
  (setq PT1 (getpoint "\nEnter text start point: "))
  (if (not *TTEXT) (setq *TTEXT 0.09375))
  (princ (strcat "\nCurrent Plot Text size = " (rtos *TTEXT 4 8) " (Dwg. text Size = " (rtos (* *TTEXT S1)) ")" ))
  (princ "\nEnter new plot text size (w/o scale correction) ")
  (setq H1 (getreal ": "))
  (if (not H1) (setq H1 *TTEXT) (setq *TTEXT H1))
  (setq H1 (* S1 H1))
  (setvar "textsize" H1)
  (setq RUN T)
  (while RUN
    (if (not *TLA2) (setq *TLA2 0))
    (princ "\nRotation angle < ")
    (princ (angtos *TLA2 1 2))
    (setq A2 (getangle PT1 " >: "))
    (if (not A2) (setq A2 *TLA2) (setq *TLA2 A2))
    (setq TLANGLE (angtos A2))
    (command "layer" "m" "text" "c" "y" "text" "")
    (command "dtext" PT1 "" TLANGLE)
    (command "layer" "m" "LEADER" "c" "r" "LEADER" "")
    (setq TXT (car (entsel "\nSelect text line for leader or return to start from arrow end: "))) (terpri)
    (if TXT (TLRUN2) (TLRUN))
    (setq PT1 (getpoint "\nEnter text start point or return to exit: "))
    (if (not PT1) (setq RUN NIL))
  );END WHILE
  (command "layer" "s" LA "")
  (princ)
)
(defun TLRUN ()
  (command "ortho" "off")
  (initget 1)
  (setq PT1 (getpoint "\nPick arrow start pt.: "))
  (initget 1)
  (setq PT2 (getpoint PT1 "\nPick 2nd leader pt.: "))
  (setq A1 (angle PT1 PT2))
  (setq D1 (* (getvar "dimasz") S1))
  (setq W1 (/ D1 6.0))
  (setq PT3 (polar PT1 A1 D1))
  (setq PT4 (polar PT3 (+ A1 (/ pi 2)) W1))
  (setq PT5 (polar PT3 (- A1 (/ pi 2)) W1))
  (command "solid" PT1 PT4 PT5 "" "")
  (command "pline" PT3 "w" "0" "0" PT2)
  (while
    (setq PT3 (getpoint PT2 "\nNext pt or return for leader stem: "))
    (command PT3)
    (setq PT2 PT3)
  );END WHILE
  (setvar "orthomode" 1)
  (setq PT3 (getpoint PT2 "\nEnter leader stem end pt or return to exit: "))
  (if PT3
    (command PT3 "")
    (command "")
  );END IF
  (command "ortho" "off")
)
(defun TLRUN2 ()
  (setq TXTA (entget TXT))
  (setq PT2 (cdr (assoc 10 TXTA)));text insert pt.
  (setq H (cdr (assoc 40 TXTA)));text height
  (setq TXTOJ (assoc 72 TXTA));org. just.
  (setq TXTNJ (cons 72 2));rt. just.
  (setq TXTB (subst TXTNJ TXTOJ TXTA))
  (entmod TXTB)
  (setq TXTB (entget TXT))
  (setq INPT (cdr (assoc 10 TXTB)))
  (setq ALPT (cdr (assoc 11 TXTB)))
  (setq D1 (distance INPT ALPT));lgth. text line
  (entmod TXTA)
  (setq D2 (* 0.0625 S1));leader gap
  (setq D3 (/ H 2));1/2 TEXT HT.
  (setq PT3 (polar PT2 (+ A2 pi) D2))
  (setq PT3 (polar PT3 (+ A2 (/ pi 2)) D3))
  (setvar "orthomode" 1)
  (setvar "snapang" A2)
  (setq PT4 (getpoint PT3 "\nEnter leader stem endpt or return for no stem: "))
  (if (not PT4)
    (progn
      (setvar "orthomode" 0)
      (initget 1)
      (setq PT4 (getpoint PT3 "\nEnter side for leader: "))
      (setq N1 (car PT3))
      (setq N2 (car PT4))
      (if (> N2 N1)
        (progn
          (setq PT3 (polar PT2 A2 (+ D1 D2)))
          (setq PT3 (polar PT3 (+ A2 (/ pi 2)) D3))
        );END PROGN
      );END IF
      (setq PT4 PT3)
    );END PROGN
    (progn
      (setq N1 (car PT3))
      (setq N2 (car PT4))
      (if (> N2 N1)
        (progn
          (setq PT3 (polar PT2 A2 (+ D1 D2)))
          (setq PT3 (polar PT3 (+ A2 (/ pi 2)) D3))
        );END PROGN
      );END IF
      (setvar "orthomode" 0)
      (setvar "snapang" 0)
    );END PROGN
  );END IF
  (command "pline" PT3 "w" "0" "0" PT4)
  (while
    (setq PT5 (getpoint PT4 "\nNext pt or return for arrow: "))
    (setq A1 (angle PT5 PT4))
    (command PT5)
    (setq PT4 PT5)
    (setq PT6 PT5)
  );END WHILE
  (command "")
  (if (not A1)
    (progn
      (setq A1 (angle PT4 PT3))
      (setq PT6 PT4)
    );END PROGN
  );END IF
  (setq D4 (* (getvar "dimasz") S1))
  (setq W1 (/ D4 6.0))
  (setq PT7 (polar PT6 A1 D4))
  (setq PT8 (polar PT7 (+ A1 (/ pi 2)) W1))
  (setq PT9 (polar PT7 (- A1 (/ pi 2)) W1))
  (command "solid" PT6 PT8 PT9 "" "")
);end tl.lsp
